﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class state_zoomin : StateMachineBehaviour {

	public float cameraSize;

	public float x_position;
	public float y_position;

	public GameObject leftLimit;
	public GameObject lowerLimit;
	public GameObject rightLimit;
	public GameObject upperLimit;

	 // OnStateEnter is called when a transition starts and the state machine starts to evaluate this state
	override public void OnStateEnter(Animator animator, AnimatorStateInfo stateInfo, int layerIndex) {
		leftLimit = animator.GetComponent<camera>().leftLimit;
		lowerLimit = animator.GetComponent<camera>().lowerLimit;
		rightLimit = animator.GetComponent<camera>().rightLimit;
		upperLimit = animator.GetComponent<camera>().upperLimit;
	}

	// OnStateUpdate is called on each Update frame between OnStateEnter and OnStateExit callbacks
	override public void OnStateUpdate(Animator animator, AnimatorStateInfo stateInfo, int layerIndex) {

		//animator.gameObject.transform.position = Vector3.Lerp(animator.gameObject.transform.position, animator.GetComponent<camera>().cameraLookAt.transform.position, 0.1f);
		animator.GetComponent<Camera>().orthographicSize = Mathf.Lerp(animator.GetComponent<Camera>().orthographicSize, cameraSize, 0.05f);

		x_position = Mathf.Clamp(animator.GetComponent<camera>().cameraLookAt.transform.position.x, leftLimit.transform.position.x, rightLimit.transform.position.x);
		y_position = Mathf.Clamp(animator.GetComponent<camera>().cameraLookAt.transform.position.y, lowerLimit.transform.position.y, upperLimit.transform.position.y);

		//animator.gameObject.transform.position = new Vector3(x_position, y_position, animator.gameObject.transform.position.z );
		//this.transform.position = new Vector3(x_position, y_position, this.transform.position.z );

		animator.gameObject.transform.position = Vector3.Lerp(animator.gameObject.transform.position, new Vector3(x_position, y_position, -10), 0.05f);

	}

	// OnStateExit is called when a transition ends and the state machine finishes evaluating this state
	override public void OnStateExit(Animator animator, AnimatorStateInfo stateInfo, int layerIndex) {
		
	}

	// OnStateMove is called right after Animator.OnAnimatorMove(). Code that processes and affects root motion should be implemented here
	//override public void OnStateMove(Animator animator, AnimatorStateInfo stateInfo, int layerIndex) {
	//
	//}

	// OnStateIK is called right after Animator.OnAnimatorIK(). Code that sets up animation IK (inverse kinematics) should be implemented here.
	//override public void OnStateIK(Animator animator, AnimatorStateInfo stateInfo, int layerIndex) {
	//
	//}
}
